<?php

//  Copyright (C) 2002-2006 Balint Kis (balint@k-i-s.net)
//  Copyright (C) 2005-2007 Solomon Peachy (pizza@shaftnet.org)

//  This program is free software; you can redistribute it and/or modify
//  it under the terms of the GNU General Public License as published by
//  the Free Software Foundation; either version 2 of the License, or
//  (at your option) any later version.

//  This program is distributed in the hope that it will be useful,
//  but WITHOUT ANY WARRANTY; without even the implied warranty of
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//  GNU General Public License for more details.

//  You should have received a copy of the GNU General Public License
//  along with this program; if not, write to the Free Software
//  Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA


include_once "include/vars.php";
include_once "include/config.php";
include_once "$theme/theme.php";
include_once "include/common.php";
include_once "include/contacts.php";
include_once "include/site.php";

$database = site_prolog();

/* Administrators cannot have a basket since it "owns" all photos of the 
   system and so it would be increasingly difficult to add shop controls 
   for the administrator 
*/

if (($po_user['type'] < $user_type['client']) || 
    ($po_user['type'] > $user_type['user'])) {
  site_epilog($database);
  header("location: login.php");
  exit();
}

site_header($page_width, "Basket");
site_navigator(11);
site_navigator_status("<a href=\"user.php\">Users</a> : My Basket", "");
print "&nbsp;<br/>\n";


$total_price = 0;
$currency = "";
$photos_in_basket = pg_query($database, "
  select shop_order.identifier,
         (select photo from photo_item where photo_item.identifier=shop_order.item) as photo,
          pieces,
         (select caption from photo, photo_item where photo.identifier=photo_item.photo and photo_item.identifier=shop_order.item),
         (select alpha_code from photo_item, currency where photo_item.currency=currency.identifier and photo_item.identifier=shop_order.item) as currency,
         (select price from photo_item where photo_item.identifier=shop_order.item) as price,
         (select comment from photo_item where photo_item.identifier=shop_order.item) as remark,
         (select shop_item.identifier from shop_item, photo_item where photo_item.shop_item=shop_item.identifier and photo_item.identifier=shop_order.item) as shop_item_id,
         (select title from photo, photo_item where photo.identifier=photo_item.photo and photo_item.identifier=shop_order.item),
         (select author from photo, photo_item where photo.identifier=photo_item.photo and photo_item.identifier=shop_order.item),
         (select users from photo, photo_item where photo.identifier=photo_item.photo and photo_item.identifier=shop_order.item),
         (select first_name from photo, photo_item, users where photo.users = users.identifier and  photo.identifier=photo_item.photo and photo_item.identifier=shop_order.item),
         (select last_name from photo, photo_item, users where photo.users = users.identifier and photo.identifier=photo_item.photo and photo_item.identifier=shop_order.item),
         (select shop_item.category from shop_item, photo_item where photo_item.shop_item=shop_item.identifier and photo_item.identifier=shop_order.item) as shop_item_category
    from shop_order
   where shop_order.client=$po_user[id]
     and transaction is null
   order by date_of_creation");


if (pg_num_rows($photos_in_basket) == 0) {
  if (pg_escape_string($_REQUEST['thanks']) == "yes") {
    $transaction_id = str_pad($_REQUEST['transaction'], 6, "0", STR_PAD_LEFT);
    print "<div align=\"center\" >Thanks for shopping with us.<p>
           The transaction identifier for your purchase is <b>$transaction_id</b>.<br/>
           Please save this number for future reference of your order.</div>";
  } else {
    print "<div align=\"center\" >There are no photos in your basket.</div>";
  }
  site_footer($database);
  site_epilog($database);
  exit();
}

print "<form method=\"post\" action=\"basket.content.php\">";
print "<input type=\"hidden\" name=\"user\" value=\"$po_user[id]\"/>";
print "<input type=\"hidden\" name=\"operation\" value=\"confirm\"/>";

print "<table width=\"100%\" border=\"0\">";
for ($i = 0; $i < pg_num_rows($photos_in_basket); $i++) {
  $photo = pg_fetch_row($photos_in_basket, $i);

  print "<tr><td align=\"right\" width=\"$cell_size\">";
  display_frame_top($cell_size, $cell_size, 10, "#E7E7E7", $theme);
  print "<a class=\"nodecor\" href=\"photo.php?photo=$photo[1]&detail_info=8\" border=\"1\"><img src=\"image.display.php?image=$photo[1]&size=1\" border=\"1\"/></a>\n";
  display_frame_bottom($cell_size, $cell_size, 10, $theme);
  print "</td><td align=\"left\" >";
  print "<table bgcolor=\"$color[table_background]\" border=\"0\" cellspacing=\"1\" cellpadding=\"4\" width=\"100%\">\n";
  if ($photo[9]) {
    print "<tr>\n";
    print "<td align=\"right\" bgcolor=\"$color[table_top]\"  width=\"10%\">Author</td>";
    print "<td align=\"left\" bgcolor=\"$color[table_body]\"  width=\"90%\">$photo[9]</td>";
    print "</tr>\n";
  }
  if ($photo[8]) {
    print "<tr>\n";
    print "<td align=\"right\" bgcolor=\"$color[table_top]\"  width=\"10%\">Title</td>";
    print "<td align=\"left\" bgcolor=\"$color[table_body]\"  width=\"90%\">$photo[8]</td>";
    print "</tr>\n";
  }
  if ($photo[3]) {
    print "<tr>\n";
    print "<td align=\"right\" bgcolor=\"$color[table_top]\"  width=\"10%\">Caption</td>";
    print "<td align=\"left\" bgcolor=\"$color[table_body]\"  width=\"90%\">$photo[3]</td>";
    print "</tr>\n";
  }
  print "<tr>\n";
  print "<td align=\"right\" bgcolor=\"$color[table_top]\"  width=\"10%\">Owner</td>";
  print "<td align=\"left\" bgcolor=\"$color[table_body]\"  width=\"90%\"><a href=\"user.php?user=$photo[10]\">$photo[12], $photo[11]</a></td>";
  print "</tr><tr>\n";
  print "<td align=\"right\" bgcolor=\"$color[table_top]\"  width=\"10%\">Details</td>";
  print "<td align=\"left\" bgcolor=\"$color[table_body]\"  width=\"90%\">";

  /* shop category selection */
  $all_shop_categories_of_this_photo = pg_query($database, "
    select distinct on (shop_category.identifier)
           shop_category.identifier, shop_category.caption
      from shop_category, photo_item, shop_item
     where shop_item.category = shop_category.identifier
       and shop_item.identifier = photo_item.shop_item
       and photo_item.photo=$photo[1]");

  $tmp_shop_category = pg_escape_string($_REQUEST["shop_category".$photo[0]]);
  if (!$tmp_shop_category)
    $tmp_shop_category = $photo[13];
  elseif ($tmp_shop_category != $photo[13]) {
    /* when changing categories the shop_item is reset to the max(identifier) item in the current category */
    pg_query($database, "
      update shop_order
         set item=(select max(photo_item.identifier)
                     from photo_item, shop_item
                    where photo_item.shop_item = shop_item.identifier
                      and photo=$photo[1]
                      and shop_item.category = $tmp_shop_category)
       where identifier=$photo[0]");

    /* we have to query to fetch the apropriate shop_item properties */
    $photo = pg_fetch_row(pg_query($database, "
      select shop_order.identifier,
             (select photo from photo_item where photo_item.identifier=shop_order.item) as photo,
              pieces,
             (select caption from photo, photo_item where photo.identifier=photo_item.photo and photo_item.identifier=shop_order.item),
             (select alpha_code from photo_item, currency where photo_item.currency=currency.identifier and photo_item.identifier=shop_order.item) as currency,
             (select price from photo_item where photo_item.identifier=shop_order.item) as price,
             (select comment from photo_item where photo_item.identifier=shop_order.item) as remark,
             (select shop_item.identifier from shop_item, photo_item where photo_item.shop_item=shop_item.identifier and photo_item.identifier=shop_order.item) as shop_item_id,
             (select title from photo, photo_item where photo.identifier=photo_item.photo and photo_item.identifier=shop_order.item),
             (select author from photo, photo_item where photo.identifier=photo_item.photo and photo_item.identifier=shop_order.item),
             (select users from photo, photo_item where photo.identifier=photo_item.photo and photo_item.identifier=shop_order.item),
             (select first_name from photo, photo_item, users where photo.users = users.identifier and  photo.identifier=photo_item.photo and photo_item.identifier=shop_order.item),
             (select last_name from photo, photo_item, users where photo.users = users.identifier and photo.identifier=photo_item.photo and photo_item.identifier=shop_order.item),
             (select shop_item.category from shop_item, photo_item where photo_item.shop_item=shop_item.identifier and photo_item.identifier=shop_order.item) as shop_item_category
        from shop_order
       where shop_order.client=$po_user[id]
         and identifier = $photo[0]"));
  }
  print "<input type=\"hidden\" name=\"shop_category".$photo[0]."\" value=\"$tmp_shop_category\"/>";
  print "<select onchange=\"location = this.options[this.selectedIndex].value;\">";
  for ($f=0; $f < pg_num_rows($all_shop_categories_of_this_photo); $f++) {
    $shop_category_single = pg_fetch_row($all_shop_categories_of_this_photo, $f);
    print "<option value=\"basket.php?shop_category".$photo[0]."=$shop_category_single[0]\"";
    if ($shop_category_single[0] == $tmp_shop_category) {
      print " selected ";
    }
    print ">$shop_category_single[1]\n";
  }
  print "</select>";

  /* shop item selection */
  $all_shop_items_of_this_photo = pg_query($database, "
    select shop_item.identifier, description
      from photo_item, shop_item
     where photo_item.shop_item=shop_item.identifier
       and photo_item.photo=$photo[1]
       and shop_item.category=$tmp_shop_category");

  $tmp_shop_item = pg_escape_string($_REQUEST["shop_item".$photo[0]]);
  if (!$tmp_shop_item)
    $tmp_shop_item = $photo[7];
  elseif ($tmp_shop_item != $photo[7]) {
    /* we do "select max" just in case - normally the subselect should always return 1 row */
    pg_query($database, "
      update shop_order
         set item=(select max(identifier)
                     from photo_item
                    where photo=$photo[1]
                      and shop_item=$tmp_shop_item)
       where identifier=$photo[0]");
    /* we have to query to fetch the apropriate shop_item properties */
    $photo = pg_fetch_row(pg_query($database, "
      select shop_order.identifier,
             (select photo from photo_item where photo_item.identifier=shop_order.item) as photo,
              pieces,
             (select caption from photo, photo_item where photo.identifier=photo_item.photo and photo_item.identifier=shop_order.item),
             (select alpha_code from photo_item, currency where photo_item.currency=currency.identifier and photo_item.identifier=shop_order.item) as currency,
             (select price from photo_item where photo_item.identifier=shop_order.item) as price,
             (select comment from photo_item where photo_item.identifier=shop_order.item) as remark,
             (select shop_item.identifier from shop_item, photo_item where photo_item.shop_item=shop_item.identifier and photo_item.identifier=shop_order.item) as shop_item_id,
             (select title from photo, photo_item where photo.identifier=photo_item.photo and photo_item.identifier=shop_order.item),
             (select author from photo, photo_item where photo.identifier=photo_item.photo and photo_item.identifier=shop_order.item),
             (select users from photo, photo_item where photo.identifier=photo_item.photo and photo_item.identifier=shop_order.item),
             (select first_name from photo, photo_item, users where photo.users = users.identifier and  photo.identifier=photo_item.photo and photo_item.identifier=shop_order.item),
             (select last_name from photo, photo_item, users where photo.users = users.identifier and photo.identifier=photo_item.photo and photo_item.identifier=shop_order.item),
             (select shop_item.category from shop_item, photo_item where photo_item.shop_item=shop_item.identifier and photo_item.identifier=shop_order.item) as shop_item_category
        from shop_order
       where shop_order.client=$po_user[id]
         and identifier = $photo[0]"));
  }
  print "<input type=\"hidden\" name=\"shop_item".$photo[0]."\" value=\"$tmp_shop_item\"/>";
  print "<select onchange=\"location = this.options[this.selectedIndex].value;\">";
  for ($f=0; $f < pg_num_rows($all_shop_items_of_this_photo); $f++) {
    $shop_item_single = pg_fetch_row($all_shop_items_of_this_photo, $f);
    print "<option value=\"basket.php?shop_item".$photo[0]."=$shop_item_single[0]\"";
    if ($shop_item_single[0] == $tmp_shop_item) {
      print " selected ";
    }
    print ">$shop_item_single[1]\n";
  }
  print "</select>";

  if ($photo[6])
    print "&nbsp;&nbsp;$photo[6]</td>";
  print "</tr><tr>\n";

  print "<td align=\"right\" bgcolor=\"$color[table_top]\"  width=\"10%\">Pieces</td>";
  print "<td align=\"left\" bgcolor=\"$color[table_body]\"  width=\"90%\">";
  $tmp_pcs = pg_escape_string($_REQUEST["pcs".$photo[0]]);
  if (!$tmp_pcs)
    $tmp_pcs = $photo[2];
  elseif ($tmp_pcs != $photo[2])
    pg_query($database, "update shop_order set pieces=$tmp_pcs where shop_order.identifier=$photo[0]");
  print "<select onchange=\"location = this.options[this.selectedIndex].value;\">";
  for ($pcs = 1; $pcs < 101; $pcs++) {
    print "<option value=\"basket.php?pcs".$photo[0]."=$pcs\"";
    if ($pcs == $tmp_pcs) {
      print " selected ";
    }
    print ">$pcs";
  }
  print "</select>";
  print "</td>\n";
  print "</tr><tr>\n";
  print "<td align=\"right\" bgcolor=\"$color[table_top]\"  width=\"10%\">Price</td>";
  if ($tmp_pcs > 1) {
    $subtotal = $tmp_pcs * $photo[5];
    $subtotal_string="subtotal for this item <b>$subtotal</b> $photo[4]";
  }
  else {
    $subtotal = $photo[5];
    $subtotal_string="";
  }
  print "<td align=\"left\" bgcolor=\"$color[table_body]\"  width=\"90%\">";
  print "<table width=\"100%\"><tr><td aling=\"left\" bgcolor=\"$color[table_body]\"  >";
  print "$photo[5] $photo[4], $subtotal_string";
  print "</td><td align=\"right\" bgcolor=\"$color[table_body]\" >";
  print "<a href=\"basket.content.php?operation=del&item=$photo[0]\">Remove this Item</a>";
  print "</td></tr></table>";

  print "</td>";
  print "</tr>\n";
  print "</table>";
  $currency = $photo[4];
  $total_price += $subtotal;
  print "</td></tr>";
}
print "</table>";

print "&nbsp;<br/>\n";
site_navigator_status("Total: <b>$currency $total_price</b>", "");
print "&nbsp;<br/>\n";

print "<center>";
print "<div >Additional Comments:</div>\n";
print "&nbsp;<br/>\n";
print "<textarea wrap=\"hard\" name=\"remark\" rows=\"5\" style=\"width: 100%;\"></textarea>\n";

print "<br/>&nbsp;<br/>\n";
print "<input type=\"image\" src=\"$theme/button.confirm.purchase.gif\" alt=\"Confirm Purchase\"/>\n";
print "</center>";
print "</form>";
print "&nbsp;<br/>\n";

site_footer($database);
site_epilog($database);
?>
