<?php

//  Copyright (C) 2002-2006 Balint Kis (balint@k-i-s.net)
//  Copyright (C) 2005-2007 Solomon Peachy (pizza@shaftnet.org)

//  This program is free software; you can redistribute it and/or modify
//  it under the terms of the GNU General Public License as published by
//  the Free Software Foundation; either version 2 of the License, or
//  (at your option) any later version.

//  This program is distributed in the hope that it will be useful,
//  but WITHOUT ANY WARRANTY; without even the implied warranty of
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//  GNU General Public License for more details.

//  You should have received a copy of the GNU General Public License
//  along with this program; if not, write to the Free Software
//  Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA

include_once "include/vars.php";
include_once "include/config.php";
include_once "include/common.php";
include_once "include/site.php";
include_once "include/orderby.php";
include_once "include/search.2.php";
include_once "$theme/theme.php";

$folder_id   = pg_escape_string($_REQUEST['folder']);
$order_by    = pg_escape_string($_REQUEST['order_by']);
$view        = $_REQUEST['view'];

$database    = site_prolog();

$arguments="";
$client=FALSE;

if (!$folder_id) {
  header("HTTP/1.1 404 Not found");
  site_header($page_width, "Display Folder");
  site_navigator(5);
  site_navigator_status("<a href=\"user.php\">Users</a> : <a href=\"user.php?user=$po_user[id]\">My Folders and Albums</a> : No folder specified", "");
  site_footer($database);
  site_epilog($database);
  exit();
}

$folder = pg_fetch_row(pg_query($database, "select caption, access_rights, users, orderby, description from folder where identifier='$folder_id'"));
if (!$folder) {
  header("HTTP/1.1 404 Not found");
  site_header($page_width, "Display Folder");
  site_navigator(5);
  site_navigator_status("<a href=\"user.php\">Users</a> : <a href=\"user.php?user=$po_user[id]\">My Folders and Albums</a> : No such folder", "");
  site_footer($database);
  site_epilog($database);
  exit();
}

if ($view != "") {
  $arguments = $arguments . "&amp;view=$view";
}

$folder_name = $folder[0];
$owner_id     = $folder[2];

if (!$order_by) {
  /* get the last value from the database */
  $order_by = $folder[3];
} else if ($po_options['order_by'] != $folder[3]) {
  if ($po_user['id'] == $owner_id) {
    /* if different, set the database, and use the new value */
    pg_query($database, "update folder set orderby='$order_by' where identifier=$folder_id");
  }
}

$arguments = $arguments . "&amp;order_by=$order_by";
$sql_query_order_by_string = $order_by_string[$order_by][0];

if (($owner_id != "") && 
    ($po_user['type'] > $user_type['disabled'])) {
  $client = pg_fetch_row(pg_query($database, "select identifier from client where users='$owner_id' and client='$po_user[id]' and status=2"));
}

if (($po_user['id'] != $owner_id) &&
    ($folder[1] == $access['private']) &&
    ($po_user['type'] != $user_type['administrator'])) {
  site_epilog($database);
  header("location: login.php");
  exit();
}

if (($po_user['id'] != $owner_id) &&
    ($folder[1] == $access['protected']) && 
    ($client == FALSE) && 
    ($po_user['type'] != $user_type['administrator'])) {
  site_epilog($database);
  header("location: login.php");
  exit();
}

$user_data = pg_fetch_row(pg_query($database, "select first_name, last_name, users.identifier, shop_enable from users, preferences where users.preferences=preferences.identifier and users.identifier=$owner_id"));

site_header($page_width, "Display Folder");

if ($po_user['type'] > $user_type['disabled']) {
  $my_data = pg_fetch_row(pg_query($database, "select num_of_rows, num_of_columns, folder_view, num_of_rows_l, popup_enable, popup_delay from  users, preferences where preferences.identifier=users.preferences and users.identifier=$po_user[id]"));
  $num_of_rows = $my_data[0];
  $num_of_columns = $my_data[1];
  if ($view=="")
    $view = $my_data[2];
  $num_of_rows_l = $my_data[3];
  $popup_enable  = $my_data[4];
  $popup_delay   = $my_data[5];
} else {
  $view = "slide";
  $num_of_rows_l  = $default_num_of_rows_in_list_view;
  $num_of_rows    = $default_num_of_rows_in_slide_view;
  $num_of_columns = $default_num_of_columns;
  $popup_enable   = $default_popup_enable;
  $popup_delay    = $default_popup_delay;
}

if ($po_user['id'] == $owner_id) {
  site_navigator(5);
  $user_display_string="My Folders and Albums";
  $my_data = pg_fetch_row(pg_query($database, "select num_of_rows, num_of_columns, folder_view, num_of_rows_l, popup_enable, popup_delay from users, preferences where preferences.identifier=users.preferences and users.identifier=$po_user[id]"));
  $num_of_rows = $my_data[0];
  $num_of_columns = $my_data[1];
  if ($view=="")
    $view = $my_data[2];
  $num_of_rows_l = $my_data[3];
  $popup_enable  = $my_data[4];
  $popup_delay   = $my_data[5];
} else {
  site_navigator(1);
  $user_display_string = sprintf("%s, %s", $user_data[1], $user_data[0]);
}

if (($po_user['id'] == $owner_id) || 
    ($po_user['type'] == $user_type['administrator'])) {
  $sql_query_photo_access_rights_string = "";
} else {
  if ($client == FALSE) {
    $sql_query_photo_access_rights_string = "and photo.access_rights = $access[public]";
  } else {
    $sql_query_photo_access_rights_string = "and photo.access_rights < $access[private]";
  }
}

$num_of_photos_a = pg_fetch_row(pg_query($database, "
   select count(photo.identifier)
     from photo
    where photo.folder = '$folder_id'
     $sql_query_photo_access_rights_string"));
$num_of_photos = $num_of_photos_a[0];

$offset = pg_escape_string($_REQUEST['offset']);
if (!$offset) {
  $offset = 0;
}

if ($view == "slide") {
  $limit = $num_of_rows * $num_of_columns;
} else {
  $limit = $num_of_rows_l;
}

if ($limit > $num_of_photos) {
  $limit = $num_of_photos;
}

$folder_photo = pg_query($database,
  "select photo.identifier, photo_version.small_image_path, photo.caption, photo.date_of_exposure, photo_dupe.date_of_creation,
          (select value from access_type where access_type.identifier=photo.access_rights) as access_rights,
          11 - (select avg(rating.value) from rating where rating.photo=photo.identifier) as rating,
          views,
          (select is_photo_for_sale(photo.identifier)) as for_sale,
          photo.title, photo.author, '' as keyword,
          photo_version.original_image_name, photo.users,
          view_location.place, view_location.country, view_location.city, view_location.state
     from photo, photo_dupe, photo_version, view_location
    where photo.folder = '$folder_id'
      and photo.identifier = photo_version.photo
      and photo.identifier = photo_dupe.photo
      and photo_dupe.key = 1
      and photo_version.master = 't'
      and photo.location = view_location.identifier
      $sql_query_photo_access_rights_string
    order by $sql_query_order_by_string
   offset $offset
    limit $limit");

$path_to_folder = get_path_to_folder($database, $folder_id);

if ($num_of_photos == 0) {
  site_navigator_status("<a href=\"user.php\">Users</a> : <a href=\"user.php?user=$user_data[2]\">$user_display_string</a>$path_to_folder : $folder[0] : is empty, or contains no public pictures", "");

  if ($folder[4] != "") {
    print "&nbsp;<br/>";
    site_navigator_status("$folder[4]", "");
  }

  if (($folder[0] != "Trash") && ($folder[0] != "Orphanage")) {
    print "&nbsp;<br/>";
    display_folders($database, "$folder_id", $po_user['id'], $po_user['type'], $owner_id, "with_header");
  }
  print "&nbsp;<br/>";
  if (($po_user['id'] == $owner_id) &&
      ($folder[0]!="Trash") &&
      ($folder[0]!="Orphanage")) {
    print "<table align=\"left\" valign=\"middle\" cellpadding=\"0\" border=\"0\">";
    print "<tr><td align=\"left\" valign=\"middle\">";
    print "<a class=\"nodecor\" href=\"photo.add.php?folder=$folder_id\"><img src=\"$theme/button.add.photos.gif\" alt=\"Add Photo\" border=\"0\"/></a>\n";
    print "</td></tr></table>";
  }
  site_footer($database);
  site_epilog($database);
  exit();
} else {
  site_navigator_status("<a href=\"user.php\">Users</a> : <a href=\"user.php?user=$user_data[2]\">$user_display_string</a>$path_to_folder : $folder[0]",  "Displaying photos " . display_photo_index_status($offset, $limit, $num_of_photos));
}

if ($folder[4] != "") {
  site_navigator_status("$folder[4]", "");
}

if (($folder[0] != "Trash") && ($folder[0] != "Orphanage")) {
  print "&nbsp;<br/>";
  display_folders($database, "$folder_id", $po_user['id'], $po_user['type'], $owner_id, "with_header");
}

print "<script language=\"JavaScript\" type=\"text/javascript\" src=\"javascript/select.js\"></script>";
print "<script language=\"JavaScript\" type=\"text/javascript\" src=\"javascript/util.js\"></script>";
print "&nbsp;<br/>";
print "<form name=\"photoList\" method=\"post\" action=\"folder.content.php\">";
print "<input type=\"hidden\" name=\"user\" value=\"$owner_id\"/>";
print "<input type=\"hidden\" name=\"view\" value=\"$view\"/>";
print "<input type=\"hidden\" name=\"return\" value=\"folder.php?folder=$folder_id$arguments&amp;offset=$offset\"/>";
print "<input type=\"hidden\" name=\"source_folder\" value=\"$folder_id\"/>\n";

if (($offset + $limit) > $num_of_photos) {
  $items = $num_of_photos - $offset;
} else {
  $items = $limit;
}

display_photo_navigator("folder", $arguments, $owner_id, $folder_id, $offset, $limit, $num_of_photos);
if ($view=="slide") {
  display_photo_slides("folder", $po_user['id'], $po_user['type'], $folder_id, $folder_photo, $items, $num_of_columns, $popup_enable, $popup_delay, $user_data[3], true, $order_by);
} else {
  print "&nbsp;<br/>\n";
  display_photo_list("folder", $po_user['id'], $po_user['type'], $folder_id, $folder_photo, $items, $user_data[3], $order_by);
  print "&nbsp;<br/>\n";
}
display_photo_navigator("folder", $arguments, $owner_id, $folder_id, $offset, $limit, $num_of_photos);

print "&nbsp;<br/>\n";
site_navigator_status("<a href=\"user.php\">Users</a> : <a href=\"user.php?user=$user_data[2]\">$user_display_string</a>$path_to_folder : $folder[0]",  "Displaying photos " . display_photo_index_status($offset, $limit, $num_of_photos));

if (($po_user['id'] == $owner_id) ||
    ($po_user['type'] == $user_type['administrator'])) {
  print "<table align=\"left\" cellpadding=\"0\" cellspacing=\"0\" border=\"0\"><tr><td>";

  print "<table align=\"left\" cellpadding=\"0\" cellspacing=\"0\" border=\"0\">";
  print "<tr>";
  print "<td align=\"left\" valign=\"middle\">";
  if ($order_by != "") {
    $order_by_argument = "&amp;order_by=$order_by";
  } else {
    $order_by_argument = "";
  }
  display_order_by_combo_with_button($order_by);
  print "</td>";

  switch ($folder[0]) {
  case "Trash":
    print "<td align=\"left\" valign=\"middle\">&nbsp;&nbsp;</td>";
    print "<td align=\"left\" valign=\"middle\">";
    print "<a class=\"nodecor\" href=\"trash.empty.php\"><img src=\"$theme/button.empty.trash.gif\" alt=\"Empty Trash\" border=\"0\"/></a>\n";
    print "</td>";
    break;
  case "Orphanage":
    break;
  default:
    if ($po_user['id'] == $owner_id) {
      print "<td align=\"left\" valign=\"middle\">&nbsp;&nbsp;</td>";
      print "<td align=\"left\" valign=\"middle\">";
      print "<a class=\"nodecor\" href=\"photo.add.php?folder=$folder_id\"><img src=\"$theme/button.add.photos.gif\" alt=\"Add Photos\" border=\"0\"/></a>\n";
      print "</td>";
    }
  }

  print "<td align=\"left\" valign=\"middle\">&nbsp;&nbsp;</td>";
  print "<td align=\"left\" valign=\"middle\">";

  if ($view=="slide")
    print "<a class=\"nodecor\" href=\"folder.php?folder=$folder_id$order_by_argument&amp;view=list&amp;offset=$offset\"><img src=\"$theme/button.list.view.gif\" alt=\"List View\" border=\"0\"/></a>\n";
  else
    print "<a class=\"nodecor\" href=\"folder.php?folder=$folder_id$order_by_argument&amp;view=slide&amp;offset=$offset\"><img src=\"$theme/button.slide.view.gif\" alt=\"Slide View\" border=\"0\"/></a>\n";
  print "</td>";

  print "<td align=\"left\" valign=\"middle\">&nbsp;&nbsp;</td>";
  print "<td align=\"left\" valign=\"middle\">";
  print "<a class=\"nodecor\" onclick=\"setChecked(); changeImage('selectButton', '$theme/button.deselect.all.gif', '$theme/button.select.all.gif')\"><img name=\"selectButton\" src=\"$theme/button.select.all.gif\" border=\"0\" alt=\"\"/></a>\n";
  print "</td>";

  if (($folder[0]!="Trash") && ($folder[0]!="Orphanage")) {
    if ($po_user['id'] == $owner_id || $po_user['type'] == $user_type['administrator']) {
      print "<td align=\"left\" valign=\"middle\">&nbsp;&nbsp;</td>";
      print "<td align=\"left\" valign=\"middle\">";
      display_printto();
      print "</td>";
      print "<td align=\"left\" valign=\"middle\">&nbsp;&nbsp;</td>";
      print "<td align=\"left\" valign=\"middle\">";
      display_export();
      print "</td>";
    }
  }

  print "</tr>";
  print "</table>";

  print "</td></tr><tr><td>";

  print "<table align=\"left\" cellpadding=\"0\" cellspacing=\"0\" border=\"0\">";
  print "<tr>";

  /* if the Orphanage is displayed, skip the Trash folder */
  if ($folder[0] == "Orphanage")
    $sql_exclude_trash = " and caption!='Trash'";

  $folder_all = pg_query($database, "select identifier, caption, parent_folder from folder where users=$owner_id and caption!='Orphanage' $sql_exclude_trash order by date_of_creation desc");
  print "<td align=\"left\" valign=\"middle\">";
  display_moveto_folder($folder_all, $folder_id, "goto");
  print "</td>";
  print "<td align=\"left\" valign=\"middle\">";
  display_moveto_folder($folder_all, $folder_id, "moveto");
  print "</td>";
  $album_all = pg_query($database, "select identifier, caption, parent_album from album where users=$owner_id and type='u' order by date_of_creation desc");
  if (pg_num_rows($album_all) > 0) {
    print "<td align=\"left\" valign=\"middle\">&nbsp;&nbsp;</td><td align=\"left\" valign=\"middle\">";
    display_linkto_album($album_all, $album_id);
    print "</td>";
  }

  print "</tr>";
  print "</table>";
  print "</td></tr></table>";

} elseif ($po_user['type'] >= $user_type['client'] && 
	  $user_data[3] == 't') {
  print "<table align=\"left\" cellpadding=\"0\" cellspacing=\"0\" border=\"0\">";
  print "<tr>";

  print "<td align=\"left\" valign=\"middle\">&nbsp;&nbsp;</td><td align=\"left\" valign=\"middle\">";
  print "<input type=\"image\" src=\"$theme/button.put.selection.to.basket.gif\" alt=\"Put Selection to Basket\"/>\n";
  print "</td>";

  print "<td align=\"left\" valign=\"middle\">&nbsp;&nbsp;</td><td align=\"left\" valign=\"middle\">";
  print "<a class=\"nodecor\" href=\"basket.php\"><img src=\"$theme/button.view.basket.gif\" alt=\"View Basket\" border=\"0\"/></a>\n";
  print "</td>";

  print "<td align=\"left\" valign=\"middle\">&nbsp;&nbsp;</td><td align=\"left\" valign=\"middle\">";
  print "<input type=\"hidden\" name=\"basket\" value=\"yes\"/>";
  print "<a class=\"nodecor\" onclick=\"setChecked('photocb'); changeImage('selectButton', '$theme/button.deselect.all.gif', '$theme/button.select.all.gif')\"><img name=\"selectButton\" src=\"$theme/button.select.all.gif\" border=\"0\" alt=\"\"/></a>\n";
  print "</td>";

  print "<td align=\"left\" valign=\"middle\">&nbsp;&nbsp;</td><td align=\"left\" valign=\"middle\">";
  $album_all = pg_query($database, "select identifier, caption, parent_album from album where users=$po_user[id] and type='c' order by date_of_creation desc");
  if (pg_num_rows($album_all) > 0) {
    display_linkto_album($album_all, $album_id);
  }
  print "</td>";

  print "</tr>";
  print "</table>";
}

print "</form>\n";

print "&nbsp;<br/>";
print "<script language=\"JavaScript\" type=\"text/javascript\" src=\"javascript/wz_tooltip.js\"></script>";
site_footer($database);
site_epilog($database);
?>
