<?php

//  Copyright (C) 2002-2006 Balint Kis (balint@k-i-s.net)
//  Copyright (C) 2005-2007 Solomon Peachy (pizza@shaftnet.org)

//  This program is free software; you can redistribute it and/or modify
//  it under the terms of the GNU General Public License as published by
//  the Free Software Foundation; either version 2 of the License, or
//  (at your option) any later version.

//  This program is distributed in the hope that it will be useful,
//  but WITHOUT ANY WARRANTY; without even the implied warranty of
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//  GNU General Public License for more details.

//  You should have received a copy of the GNU General Public License
//  along with this program; if not, write to the Free Software
//  Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA

$datebook_data = array("clients"   => array("idx" => 1, "active_img" => "$theme/navigator.db.clients.a.gif",        "img" => "$theme/navigator.db.clients.gif",        link => "my.datebook.php?selector=1", "alt" => " Clients "),
                       "orders"    => array("idx" => 2, "active_img" => "$theme/navigator.db.pending.orders.a.gif", "img" => "$theme/navigator.db.pending.orders.gif", link => "my.datebook.php?selector=2", "alt" => " Pending Orders "),
                       "shipments" => array("idx" => 3, "active_img" => "$theme/navigator.db.shipments.a.gif",      "img" => "$theme/navigator.db.shipments.gif",      link => "my.datebook.php?selector=3", "alt" => " Shipments "));


function displayMerchandiserTransaction($database, $user_id, $transaction_status) {
  global $style;
  global $color;

  $all_pending_transactions = pg_query($database, "
     select distinct on (shop_transaction.identifier)
         shop_transaction.identifier,
         (select sum(shop_order.pieces*photo_item.price) from shop_order, photo_item where shop_order.transaction=shop_transaction.identifier and shop_order.item=photo_item.identifier) as total_price,
         (select sum(pieces) from shop_order where shop_order.transaction=shop_transaction.identifier) as items,
         (select alpha_code from shop_order, photo_item, currency where shop_order.transaction=shop_transaction.identifier and shop_order.item=photo_item.identifier and photo_item.currency=currency.identifier limit 1) as total_price,
         client, first_name, last_name,
         shop_transaction.remark
    from shop_transaction, shop_order, users, photo_item, photo
   where shop_order.client=users.identifier
     and shop_order.item=photo_item.identifier
     and photo_item.photo=photo.identifier
     and photo.users=$user_id
     and shop_transaction.status=$transaction_status
     and shop_transaction.identifier=shop_order.transaction
   order by shop_transaction.identifier desc");

  if (pg_num_rows($all_pending_transactions) == 0) {
    if ($transaction_status)
      print "<div align=\"center\" >There are no pending merchandiser transactions.</div>";
    return;
  }

  print "<table align=\"center\" bgcolor=\"$color[table_background]\" border=\"0\" cellspacing=\"1\" cellpadding=\"3\" width=\"100%\"><tr>\n";
  print "<td align=\"left\" bgcolor=\"$color[table_header]\"  width=\"10%\">Order</td>";
  print "<td align=\"left\" bgcolor=\"$color[table_header]\"  width=\"8%\">Value</td>";
  print "<td align=\"left\" bgcolor=\"$color[table_header]\"  width=\"8%\">Pieces</td>";
  print "<td align=\"left\" bgcolor=\"$color[table_header]\"  width=\"14%\">Client</td>";
  print "<td align=\"left\" bgcolor=\"$color[table_header]\"  width=\"60%\">Client's Remark</td>";
  print "</tr>";

  for ($item = 0; $item < pg_num_rows($all_pending_transactions); $item++) {
    $transaction = pg_fetch_row($all_pending_transactions, $item);
    $display_transaction_id = str_pad($transaction[0], 6, "0", STR_PAD_LEFT);
    print "<tr>";
    print "<td align=\"left\" bgcolor=\"$color[table_body]\" ><a href=\"shop.order.php?order=$display_transaction_id\">$display_transaction_id</a></td>";
    print "<td align=\"left\" bgcolor=\"$color[table_body]\" >$transaction[3] $transaction[1]</td>";
    print "<td align=\"left\" bgcolor=\"$color[table_body]\" >$transaction[2]</td>";
    print "<td align=\"left\" bgcolor=\"$color[table_body]\" ><a href=\"user.php?user=$transaction[4]\">$transaction[6], $transaction[5]</a></td>";
    print "<td align=\"left\" bgcolor=\"$color[table_body]\" >$transaction[7]</td>";
    print "</tr>";
  }

  print "</table>";
  print "</p>";
}


function displayClientTransaction($database, $user_id, $transaction_status) {
  global $style;
  global $color;

  $all_pending_transactions = pg_query($database, "
     select distinct on (shop_transaction.identifier)
         shop_transaction.identifier,
         (select sum(shop_order.pieces*photo_item.price) from shop_order, photo_item where shop_order.transaction=shop_transaction.identifier and shop_order.item=photo_item.identifier) as total_price,
         (select sum(pieces) from shop_order where shop_order.transaction=shop_transaction.identifier) as items,
         (select alpha_code from shop_order, photo_item, currency where shop_order.transaction=shop_transaction.identifier and shop_order.item=photo_item.identifier and photo_item.currency=currency.identifier limit 1) as total_price,
         client, first_name, last_name,
         shop_transaction.remark
    from shop_transaction, shop_order, users, photo_item, photo
   where shop_order.client=users.identifier
     and shop_order.item=photo_item.identifier
     and photo_item.photo=photo.identifier
     and shop_order.client=$user_id
     and shop_transaction.status=$transaction_status
     and shop_transaction.identifier=shop_order.transaction
   order by shop_transaction.identifier desc");

  if (pg_num_rows($all_pending_transactions) == 0) {
    if ($transaction_status)
      print "<div align=\"center\" >There are no pending client transactions.</div>";
    return;
  }

  print "<table align=\"center\" bgcolor=\"$color[table_background]\" border=\"0\" cellspacing=\"1\" cellpadding=\"3\" width=\"100%\"><tr>\n";
  print "<td align=\"left\" bgcolor=\"$color[table_header]\"  width=\"10%\">Order</td>";
  print "<td align=\"left\" bgcolor=\"$color[table_header]\"  width=\"8%\">Value</td>";
  print "<td align=\"left\" bgcolor=\"$color[table_header]\"  width=\"8%\">Pieces</td>";
  print "<td align=\"left\" bgcolor=\"$color[table_header]\"  width=\"14%\">Client</td>";
  print "<td align=\"left\" bgcolor=\"$color[table_header]\"  width=\"60%\">Client's Remark</td>";
  print "</tr>";

  for ($item = 0; $item < pg_num_rows($all_pending_transactions); $item++) {
    $transaction = pg_fetch_row($all_pending_transactions, $item);
    $display_transaction_id = str_pad($transaction[0], 6, "0", STR_PAD_LEFT);
    print "<tr>";
    print "<td align=\"left\" bgcolor=\"$color[table_body]\" ><a href=\"shop.order.php?order=$display_transaction_id\">$display_transaction_id</a></td>";
    print "<td align=\"left\" bgcolor=\"$color[table_body]\" >$transaction[3] $transaction[1]</td>";
    print "<td align=\"left\" bgcolor=\"$color[table_body]\" >$transaction[2]</td>";
    print "<td align=\"left\" bgcolor=\"$color[table_body]\" ><a href=\"user.php?user=$transaction[4]\">$transaction[6], $transaction[5]</a></td>";
    print "<td align=\"left\" bgcolor=\"$color[table_body]\" >$transaction[7]</td>";
    print "</tr>";
  }

  print "</table>";
  print "</p>";
}


function displayDayEventHTML($event_id, $event_description, $start_date, $end_date, $view, $bgcolor) {
  global $color;
  global $style;

  if (strlen($event_description) > 30)
    $event_description = sprintf("%0.30s", $event_description);

  print "<table border=\"0\" cellspacing=\"0\" cellpadding=\"0\" width=\"100%\">\n";
  print "<tr>\n";
  print "<td align=\"left\">";

  print "<table border=\"0\" cellspacing=\"0\" cellpadding=\"0\" width=\"100%\">\n";
  print "<tr>\n";
  print "<td align=\"left\" valign=\"middle\" bgcolor=\"$bgcolor\" >".generate_date_html($start_date, "time", 1)."</td>\n";
  print "<td align=\"center\" valign=\"middle\" bgcolor=\"$bgcolor\" >";
  print "<a href=\"event.php?event=$event_id&view=$view\">$event_description</a></td>\n";
  print "</tr>\n";
  print "</table>\n";

  print "</td>\n";
  print "<td align=\"right\" valign=\"middle\" bgcolor=\"$bgcolor\" >".generate_date_html($end_date, "time", 1)."</td>\n";
  print "</tr>\n";
  print "</table>\n";
}

function displayWeekEventHTML($event_id, $event_description, $start_date, $end_date, $view, $bgcolor) {
  global $color;
  global $style;

  if (strlen($event_description) > 15)
    $event_description = sprintf("%0.15s", $event_description);

  print "<table border=\"0\" cellspacing=\"0\" cellpadding=\"0\" width=\"100%\">\n";
  print "<tr><td align=\"left\" bgcolor=\"$bgcolor\" >".generate_date_html($start_date, "time", 1)."-".generate_date_html($end_date, "time", 1).print "</td></tr>";

  print "<tr>\n";
  print "<td align=\"left\" valign=\"middle\" bgcolor=\"$bgcolor\" >";
  print "<a href=\"event.php?event=$event_id&view=$view\">$event_description</a></td>\n";
  print "</tr>\n";
  print "</table>\n";
}

function displayMonthEventHTML($event_id, $start_date, $end_date, $view, $bgcolor) {
  global $color;
  global $style;

  print "<table align=\"right\" border=\"0\" cellspacing=\"0\" cellpadding=\"0\" width=\"100%\">\n";
  print "<tr><td align=\"left\" bgcolor=\"$bgcolor\" ><a href=\"event.php?event=$event_id&view=$view\">\n" .generate_date_html($start_date, "time", 1). "-".generate_date_html($end_date, "time", 1);
  print "</a></td></tr>";
  print "</table>\n";
}


function displayDayHTML($database, $user_id, $year, $month, $day, $cal_start_hour, $cal_end_hour, $dayNames, $startDay, $view) {
  global $color;
  global $style;

  $date = sprintf("%04d-%02d-%02d", $year, $month, $day);
  $result = pg_query($database, "select identifier, start_date, end_date, remark from calendar where users=$user_id and (start_date ~* '$date' or end_date ~* '$date') order by start_date");

  $num_of_events = pg_num_rows($result);

  for ($event = 0; $event < $num_of_events; $event++) {
    $event_data = pg_fetch_row($result, $event);
    $start_hour = (int)substr($event_data[1], 11, 2);
    $end_hour   = (int)substr($event_data[2], 11, 2);
    if ($start_hour < $cal_start_hour)
      $cal_start_hour = $start_hour;
    if ($end_hour > $cal_end_hour)
      $cal_end_hour = $end_hour;
  }

  $cells = $cal_end_hour - $cal_start_hour + 1;

  print "<table align=\"center\" bgcolor=\"$color[table_background]\" border=\"0\" cellspacing=\"1\" cellpadding=\"3\" width=\"100%\">\n";
  print "<tr>\n";
  $cell_width=floor(90/($cal_end_hour - $cal_start_hour + 1));
  for ($i = $cal_start_hour; $i <= $cal_end_hour; $i ++)
    print "<td align=\"left\" valign=\"top\" bgcolor=\"$color[table_header]\"  width=\"$cell_width%\">$i</td>\n";
  print "<td align=\"left\"   valign=\"middle\" bgcolor=\"$color[table_header]\"  width=\"10%\" colspan=\"2\">";
  print "<a href=\"event.add.php?year=$year&amp;month=$month&amp;day=$day\">Add</a></td>\n";
  print "</tr>\n";

  for ($event = 0; $event < $num_of_events; $event++) {
    $event_data = pg_fetch_row($result, $event);
    $start_hour = substr($event_data[1], 11, 2);
    $end_hour   = substr($event_data[2], 11, 2);
    $end_minute = substr($event_data[2], 14, 2);
    print "<tr>\n";
    for ($i = $cal_start_hour; $i < $start_hour; $i ++)
      print "<td align=\"center\" valign=\"top\" bgcolor=\"$color[table_header]\" >&nbsp;</td>\n";

    $event_cells = $end_hour - $start_hour;
    if ($end_minute != 0)
      $event_cells++;

    print "<td align=\"center\" valign=\"top\" bgcolor=\"$color[selected]\"  colspan=\"$event_cells\">";
    displayDayEventHTML($event_data[0], $event_data[3], $event_data[1], $event_data[2], $view, $color[selected]);
    print "</td>\n";

    for ($i = $end_hour; $i < $cal_end_hour; $i ++)
      print "<td align=\"center\" valign=\"top\" bgcolor=\"$color[highlight]\" >&nbsp;</td>\n";

    if (($end_hour != $start_hour) && ($end_minute == 0))
      print "<td align=\"center\" valign=\"top\" bgcolor=\"$color[highlight]\" >&nbsp;</td>\n";

    print "<td align=\"center\" valign=\"top\" bgcolor=\"$color[table_body]\" ><a href=event.edit.php?event=$event_data[0]>Edit</a></td>\n";
    print "<td align=\"center\" valign=\"top\" bgcolor=\"$color[table_body]\" ><a href=event.del.php?event=$event_data[0]>Delete</a></td>\n";
    print "</tr>";
  }
  print "<tr>\n";
  $cells += 2;
  if ($num_of_events == 0)
    $message="No events for this day";
  else
    $message="&nbsp;";
  print "<td align=\"left\" valign=\"top\" bgcolor=\"$color[table_header]\"  colspan=\"$cells\">$message</td>\n";
  print "</tr>";
  print "</table>\n";
}

function displayWeekHTML($database, $user_id, $year, $week, $dayNames, $startDay, $view) {
  global $color;
  global $style;

  $firstDayOfWeek = getFirstDayOfWeek($year, $week, $startDay);
  print "<table bgcolor=\"$color[table_background]\" border=\"0\" cellspacing=\"1\" cellpadding=\"4\" width=\"100%\">\n";
  print "<tr>\n";
  for ($dayIncrement = 0; $dayIncrement < 7; $dayIncrement++) {
    $curDate = adjustDay($firstDayOfWeek[0], $firstDayOfWeek[1], $firstDayOfWeek[2] + $dayIncrement);
    print "<td align=\"center\" valign=\"top\" bgcolor=\"$color[table_header]\"  width=\"14%\"><a href=\"my.datebook.php?view=1&amp;year=$curDate[0]&amp;month=$curDate[1]&amp;day=$curDate[2]\"><b>" . $dayNames[($startDay+$dayIncrement)%7] . ", $curDate[2]</b></a></td>\n";
  }
  print "</tr>";
  print "<tr>\n";
  for ($dayIncrement = 0; $dayIncrement < 7; $dayIncrement++) {
    $curDate = adjustDay($firstDayOfWeek[0], $firstDayOfWeek[1], $firstDayOfWeek[2] + $dayIncrement);
    $today = getdate(time());
    if ($curDate[0] == $today["year"] && $curDate[1] == $today["mon"] && $curDate[2] == $today["mday"])
      $bgcolor = $color[selected];
    else
      $bgcolor = $color[highlight];

    print "<td align=\"right\"  valign=\"top\" bgcolor=\"$bgcolor\" >";

    $date = sprintf("%04d-%02d-%02d", $curDate[0], $curDate[1], $curDate[2]);
    $result = pg_query($database, "select identifier, start_date, end_date, remark from calendar where users=$user_id and (start_date ~* '$date' or end_date ~* '$date') order by start_date");
    $num_of_events = pg_num_rows($result);
    for ($event = 0; $event < $num_of_events; $event++) {
      $event_data = pg_fetch_row($result, $event);
      displayWeekEventHTML($event_data[0], $event_data[3], $event_data[1], $event_data[2], $view, $bgcolor);
    }

    print "</td>\n";
  }
  print "</tr>\n";
  print "<tr>\n";
  print "<td align=\"right\" valign=\"top\" bgcolor=\"$color[table_header]\"  colspan=\"8\">&nbsp;</td>\n";
  print "</tr>";
  print "</table>\n";
}

function displayMonthHTML($database, $user_id, $year, $month, $dayNames, $startDay, $view) {
  global $color;
  global $style;

  print "<table bgcolor=\"$color[table_background]\" border=\"0\" cellspacing=\"1\" cellpadding=\"4\" width=\"100%\">\n";
  print "<tr>\n";
  print "<td align=\"center\" valign=\"middle\" bgcolor=\"$color[table_header]\"  width=\"2%\">Week</td>\n";
  for ($dayIncrement = 0; $dayIncrement < 7; $dayIncrement++)
    print "<td align=\"center\" valign=\"top\" bgcolor=\"$color[table_header]\"  width=\"14%\"><b>" . $dayNames[($startDay + $dayIncrement) % 7] . "</b></td>\n";
  print "</tr>\n";


  // get timestamp of first day of month at noon
  $timestamp = mktime(12, 0, 0, $month, 1, $year);
  // get first day index 0 Sunday
  $date = getdate($timestamp);
  $day = $startDay + 1 - $date["wday"];

  if ($day > 1)
    $day -= 7;

  $today = getdate(time());
  $daysInMonth = getDaysInMonth($year, $month);

  while ($day <= $daysInMonth) {
    print "<tr>\n";
    $curDate = adjustDay($year, $month, $day);
    $weekNumber=getWeekNumber($curDate[0], $curDate[1], $curDate[2], $startDay);
    print "<td align=\"center\" valign=\"top\" bgcolor=\"$color[table_body]\" >";
    print "<a href=\"my.datebook.php?view=2&amp;year=$year&amp;month=$curDate[1]&amp;day=$curDate[2]\">$weekNumber</a></td>\n";
    for ($i = 0; $i < 7; $i++) {
      $curDate = adjustDay($year, $month, $day);
      $bgcolor = $color[highlight];
      if ($curDate[2]!=$day)
        $bgcolor = $color[table_body];
      if ($year == $today["year"] && $month == $today["mon"] && $day == $today["mday"])
        $bgcolor = $color[selected];
      print "<td align=\"left\" valign=\"top\" bgcolor=\"$bgcolor\" >";
      print "<table border=\"0\" cellspacing=\"0\" cellpadding=\"0\" width=\"100%\"><tr><td align=\"left\" valign=\"top\" >";
      print "<a href=\"my.datebook.php?view=1&amp;year=$curDate[0]&amp;month=$curDate[1]&amp;day=$curDate[2]\">$curDate[2]</a>&nbsp;";
      print "</td><td align=\"right\" valign=\"top\" bgcolor=\"$bgcolor\" >";
      $date = sprintf("%04d-%02d-%02d", $curDate[0], $curDate[1], $curDate[2]);
      $result = pg_query($database, "select identifier, start_date, end_date from calendar where users=$user_id and (start_date ~* '$date' or end_date ~* '$date') order by start_date");
      $num_of_events = pg_num_rows($result);
      for ($event = 0; $event < $num_of_events; $event++) {
        $event_data = pg_fetch_row($result, $event);
        displayMonthEventHTML($event_data[0], $event_data[1], $event_data[2], $view, $bgcolor);
      }
      print "</td></tr></table>";

      print "</td>\n";
      $day++;
    }
    print "</tr>\n";
  }
  print "<tr>\n";
  print "<td align=\"right\" valign=\"top\" bgcolor=\"$color[table_header]\"  colspan=\"8\">&nbsp;</td>\n";
  print "</tr>";
  print "</table>\n";
}

?>
