<?php

//  Copyright (C) 2002-2006 Balint Kis (balint@k-i-s.net)
//  Copyright (C) 2005-2007 Solomon Peachy (pizza@shaftnet.org)

//  This program is free software; you can redistribute it and/or modify
//  it under the terms of the GNU General Public License as published by
//  the Free Software Foundation; either version 2 of the License, or
//  (at your option) any later version.

//  This program is distributed in the hope that it will be useful,
//  but WITHOUT ANY WARRANTY; without even the implied warranty of
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//  GNU General Public License for more details.

//  You should have received a copy of the GNU General Public License
//  along with this program; if not, write to the Free Software
//  Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA

include_once "common.php";
include_once "search.2.php";

$tools_data = array("bulkupdate"      => array("idx" => 1, "active_img" => "$theme/navigator.tl.bulkupdate.a.gif",          "img" => "$theme/navigator.tl.bulkupdate.gif",          'link' => "my.tools.php?selector=1", "alt" => " Bulk Update "),
                    "shop_item_maker" => array("idx" => 2, "active_img" => "$theme/navigator.tl.shop.item.generator.a.gif", "img" => "$theme/navigator.tl.shop.item.generator.gif", 'link' => "my.tools.php?selector=2", "alt" => " Shop Item Generator "),
                    "generator"       => array("idx" => 3, "active_img" => "$theme/navigator.tl.xmlgen.a.gif",              "img" => "$theme/navigator.tl.xmlgen.gif",              'link' => "my.tools.php?selector=3", "alt" => " XML Template Generator "),
                    "converter"       => array("idx" => 4, "active_img" => "$theme/navigator.tl.xmlconv.a.gif",             "img" => "$theme/navigator.tl.xmlconv.gif",             'link' => "my.tools.php?selector=4", "alt" => " XML Converter "),
                    "content_indexer" => array("idx" => 5, "active_img" => "$theme/navigator.tl.content.indexer.a.gif",     "img" => "$theme/navigator.tl.content.indexer.gif",     'link' => "my.tools.php?selector=5", "alt" => " Content Indexer "));

function display_xml_template_generator($database, $user_id) {
  global $style;
  global $color;
  global $theme;

  $users_location  = pg_query($database, "select identifier, country, state, city, place from view_location order by country, state, city, place");
  $users_folder    = pg_query($database, "select identifier, caption, parent_folder  from folder where users=$user_id and caption!='Trash' and caption!='Orphanage' order by date_of_creation desc");
  $users_camera    = pg_query($database, "select identifier, name, model, variation from view_camera where users=$user_id");
  $users_lens      = pg_query($database, "select identifier, name, model, variation, s_min_aperture, s_max_aperture, s_min_focal_length, s_max_focal_length from view_lens where users=$user_id");
  $users_film      = pg_query($database, "select identifier, name, model, iso       from view_film where users=$user_id");
  $users_flash     = pg_query($database, "select identifier, name, model, variation from view_flash where users=$user_id");
  $users_scanner   = pg_query($database, "select identifier, name, model, variation from view_scanner where users=$user_id");
  $users_filter    = pg_query($database, "select identifier, name, model, variation from view_filter where users=$user_id");
  $users_support   = pg_query($database, "select identifier, name, model, variation from view_support where users=$user_id");

  $aperture        = pg_query($database, "select identifier, value from aperture");
  $focal_length    = pg_query($database, "select identifier, value from focal_length");
  $shutter         = pg_query($database, "select identifier, value from shutter");
  $ev_comp         = pg_query($database, "select identifier, value from ev_comp");
  $camera_metering = pg_query($database, "select identifier, value from camera_metering");
  $camera_program  = pg_query($database, "select identifier, value from camera_program");
  $flash_mode      = pg_query($database, "select identifier, value from flash_mode");
  $scan_resolution = pg_query($database, "select identifier, value from scan_resolution");
  $scan_bitdepth   = pg_query($database, "select identifier, value from scan_bitdepth");
  $scan_multiscan  = pg_query($database, "select identifier, value from scan_multiscan");
  $iso_override    = pg_query($database, "select identifier, value from film_iso");

  print "<form method=\"post\" action=\"xml.generator.php\" enctype=\"multipart/form-data\">\n";

  print "&nbsp;<br />";

  print "<table align=\"center\" bgcolor=\"$color[table_background]\" border=\"0\" cellspacing=\"1\" cellpadding=\"3\" width=\"100%\">\n";
  print "<tr>\n";
  print "<td align=\"left\" bgcolor=\"$color[table_top]\"  colspan=\"2\">Fill in the image details and default values</td>\n";
  print "</tr>\n";
  print "<tr><td align=\"right\" bgcolor=\"$color[table_header]\"  width=\"25%\">Image file name</td>\n";
  print "<td align=\"left\" bgcolor=\"$color[table_body]\"  width=\"75%\">";
  print "<input type=\"text\" name=\"file_name\" value=\"$file_name\" title=\"Root of the file name - the part which is constant\"/>";

  print "<select name=\"file_number_digits\" title=\"Number of digits in the file name including 0. For 00234 this number is 5\">";
  for ($i=1; $i < 11; $i++) {
    print "<option value=$i>$i";
  }
  print "</select>";
  print " . <input type=\"text\" name=\"file_format\" value=\"$file_format\" size=\"5\" title=\"File format, ex: jpg, gif, ...\"/>";

  print"</td>\n</tr>\n";
  print "<tr><td align=\"right\" bgcolor=\"$color[table_header]\"  width=\"25%\">Start number</td>\n<td align=\"left\" bgcolor=\"$color[table_body]\"  width=\"75%\">";
  print "<input type=\"text\" name=\"file_number_start\" value=\"$file_number_start\" size=\"10\" title=\"File start number - the number of the first photo\"/>";
  print "</td>\n</tr>\n";
  print "<tr><td align=\"right\" bgcolor=\"$color[table_header]\"  width=\"25%\">Number of frames</td>\n<td align=\"left\" bgcolor=\"$color[table_body]\"  width=\"75%\">";
  print "<input type=\"text\" name=\"frame_number\" value=\"$frame_number\" size=\"10\" title=\"For how many photos you want to generate the XML file\"/>";
  print "</td>\n</tr>\n";
  print "<tr><td align=\"right\" bgcolor=\"$color[table_header]\"  width=\"25%\">Folder</td>            <td align=\"left\" bgcolor=\"$color[table_body]\" >";
  display_folder_combo("folder", $users_folder, $current_folder, "");
  print "</td></tr>\n";

  print "<tr><td align=\"right\" bgcolor=\"$color[table_header]\"  width=\"25%\">Title</td><td align=\"left\" bgcolor=\"$color[table_body]\" >";
  print "<input type=\"text\" name=\"title\" size=\"60\" title=\"The title of the Photo\"/></td></tr>\n";
  print "<tr><td align=\"right\" bgcolor=\"$color[table_header]\"  width=\"25%\">Author</td><td align=\"left\" bgcolor=\"$color[table_body]\" >";
  print "<input type=\"text\" name=\"author\" size=\"60\" title=\"Photographer's Name\"/></td></tr>\n";
  print "<tr><td align=\"right\" bgcolor=\"$color[table_header]\"  width=\"25%\">Keywords</td><td align=\"left\" bgcolor=\"$color[table_body]\" >";
  print "<textarea wrap=\"hard\"  name=\"keywords\" title=\"Keywords, separated by semicolons\" rows=3 cols=\"60\"></textarea></td></tr>\n";
  print "<tr><td align=\"right\" bgcolor=\"$color[table_header]\"  width=\"25%\">Caption</td><td align=\"left\" bgcolor=\"$color[table_body]\" >";
  print "<textarea wrap=\"hard\"  name=\"caption\" rows=\"7\" cols=\"60\"></textarea></td></tr>\n";

  print "<tr><td align=\"right\" bgcolor=\"$color[table_header]\"  width=\"25%\">Exposure date</td><td align=\"left\" bgcolor=\"$color[table_body]\" >";
  display_date_input_form("exposure_timestamp", "");
  print "</td></tr>\n";
  print "<tr><td align=\"right\" bgcolor=\"$color[table_header]\"  width=\"25%\">Location</td><td align=\"left\" bgcolor=\"$color[table_body]\" >";
  display_combo("location", $users_location, 0, ", ", 1);
  print "</td></tr>\n";
  print "<tr><td align=\"right\" bgcolor=\"$color[table_header]\"  width=\"25%\">Storage Location</td><td align=\"left\" bgcolor=\"$color[table_body]\" >";
  display_storage_location_combo("storage_location_type", "");
  print "<input type=\"text\" name=\"storage_location_id\" size=\"10\" title=\"Storage location identifier - this will be incremented when the index wraps around\"/> -
         <input type=\"text\" name=\"storage_index\" size=\"4\" title=\"Storage location index - this must be a number and will be incremented for each photo\"/> :
         <input type=\"text\" name=\"storage_size\" size=\"4\" title=\"Storage location size - the storage index will wrap around when reaches this limit\"/>";
  print "</td></tr>\n";
  print "<tr><td align=\"right\" bgcolor=\"$color[table_header]\"  width=\"25%\">Access</td><td align=\"left\" bgcolor=\"$color[table_body]\" >";
  display_access_combo("access_rights", "t", "");
  print "</td></tr>\n";
  print "<tr><td align=\"right\" bgcolor=\"$color[table_header]\"  width=\"25%\">High Resolution Original</td><td align=\"left\" valign=\"middle\" bgcolor=\"$color[table_body]\" >";
  display_hide_original_combo("hide_original", "t");
  print "</td></tr>\n";
  print "<tr><td align=\"right\" bgcolor=\"$color[table_header]\"  width=\"25%\">Camera</td><td align=\"left\" bgcolor=\"$color[table_body]\" >";
  display_combo("camera", $users_camera, 0, "", 0);
  print "</td></tr>\n";
  print "<tr><td align=\"right\" bgcolor=\"$color[table_header]\"  width=\"25%\">Camera Metering</td><td align=\"left\" bgcolor=\"$color[table_body]\" >\n";
  display_combo("camera_metering", $camera_metering, 0, "", 0);
  print "</td></tr>\n";
  print "<tr><td align=\"right\" bgcolor=\"$color[table_header]\"  width=\"25%\">Camera Program</td><td align=\"left\" bgcolor=\"$color[table_body]\" >\n";
  display_combo("camera_program", $camera_program, 0, "", 0);
  print "</td></tr>\n";
  print "<tr><td align=\"right\" bgcolor=\"$color[table_header]\"  width=\"25%\">Lens</td><td align=\"left\" bgcolor=\"$color[table_body]\" >\n";
  display_lens_combo("lens", $users_lens, 0, 0, 0);
  print "</td></tr>\n";
  print "<tr><td align=\"right\" bgcolor=\"$color[table_header]\"  width=\"25%\">Focal Length</td><td align=\"left\" bgcolor=\"$color[table_body]\" >\n";
  display_combo("focal_length", $focal_length, 0, "", 0);
  print "</td></tr>\n";
  print "<tr><td align=\"right\" bgcolor=\"$color[table_header]\"  width=\"25%\">Filter</td><td align=\"left\" bgcolor=\"$color[table_body]\" >\n";
  display_combo("filter", $users_filter, 0, "", 0);
  print "</td></tr>\n";
  print "<tr><td align=\"right\" bgcolor=\"$color[table_header]\"  width=\"25%\">Film</td><td align=\"left\" bgcolor=\"$color[table_body]\" >\n";
  display_combo("film", $users_film, 0, "", 0);
  print "</td></tr>\n";
  print "<tr><td align=\"right\" bgcolor=\"$color[table_header]\"  width=\"25%\">Film ISO Override</td><td align=\"left\" bgcolor=\"$color[table_body]\" >\n";
  display_combo("iso_override", $iso_override, 0, "", 0);
  print "</td></tr>\n";
  print "<tr><td align=\"right\" bgcolor=\"$color[table_header]\"  width=\"25%\">Aperture</td><td align=\"left\" bgcolor=\"$color[table_body]\" >\n";
  display_combo("aperture", $aperture, 0, "", 0);
  print "</td></tr>\n";
  print "<tr><td align=\"right\" bgcolor=\"$color[table_header]\"  width=\"25%\">Shutter Speed</td><td align=\"left\" bgcolor=\"$color[table_body]\" >\n";
  display_combo("shutter", $shutter, 0, "", 0);
  print "</td></tr>\n";
  print "<tr><td align=\"right\" bgcolor=\"$color[table_header]\"  width=\"25%\">Exposure Compensation</td><td align=\"left\" bgcolor=\"$color[table_body]\" >\n";
  display_combo("exp_comp", $ev_comp, 0, "", 0);
  print "</td></tr>\n";
  print "<tr><td align=\"right\" bgcolor=\"$color[table_header]\"  width=\"25%\">Ev Difference</td><td align=\"left\" bgcolor=\"$color[table_body]\" >\n";
  display_combo("exp_diff", $ev_comp, 0, "", 0);
  print "</td></tr>\n";
  print "<tr><td align=\"right\" bgcolor=\"$color[table_header]\"  width=\"25%\">Flash</td><td align=\"left\" bgcolor=\"$color[table_body]\" >\n";
  display_combo("flash", $users_flash, 0, "", 0);
  print "</td></tr>\n";
  print "<tr><td align=\"right\" bgcolor=\"$color[table_header]\"  width=\"25%\">Flash Mode</td><td align=\"left\" bgcolor=\"$color[table_body]\" >\n";
  display_combo("flash_mode", $flash_mode, 0, "", 0);
  print "</td></tr>\n";
  print "<tr><td align=\"right\" bgcolor=\"$color[table_header]\"  width=\"25%\">Flash Compensation</td><td align=\"left\" bgcolor=\"$color[table_body]\" >\n";
  display_combo("flash_comp", $ev_comp, 0, "", 0);
  print "</td></tr>\n";
  print "<tr><td align=\"right\" bgcolor=\"$color[table_header]\"  width=\"25%\">Scanner</td><td align=\"left\" bgcolor=\"$color[table_body]\" >\n";
  display_combo("scanner", $users_scanner, 0, "", 0);
  print "</td></tr>\n";
  print "<tr><td align=\"right\" bgcolor=\"$color[table_header]\" width=\"25%\">Colorspace</td><td align=\"left\" bgcolor=\"$color[table_body]\" >\n";
  display_colorspace_combo("colorspace", 1);
  print "</td></tr>\n";
  print "<tr><td align=\"right\" bgcolor=\"$color[table_header]\"  width=\"25%\">Scan Parameters</td><td align=\"left\" valign=\"middle\" bgcolor=\"$color[table_body]\" >\n";
  display_combo("scan_resolution", $scan_resolution, 0, "", 0);
  print "dpi &nbsp;\n";
  display_combo("scan_bitdepth", $scan_bitdepth, 0, "", 0);
  print "bits &nbsp;\n";
  display_combo("scan_multiscan", $scan_multiscan, 0, "", 0);
  print "passes &nbsp;\n";
  print "</td></tr>\n";
  print "<tr><td align=\"right\" bgcolor=\"$color[table_header]\"  width=\"25%\">Support</td><td align=\"left\" bgcolor=\"$color[table_body]\" >\n";
  display_combo("support", $users_support, 0, "", 0);
  print "</td></tr>\n";
  print "<tr><td align=\"right\" bgcolor=\"$color[table_header]\"  width=\"30%\" nowrap>Copyright Statement</td>\n";
  print "<td align=\"left\" bgcolor=\"$color[table_body]\"  width=\"70%\">";
  print "<textarea wrap=\"hard\"  name=\"copyright\" rows=\"7\" cols=\"60\">$my_preferences[0]</textarea>\n";
  print "</td></tr>\n";
  print "</table>\n";
  print "&nbsp;<br />";
  print "<input type=\"image\" src=\"$theme/button.submit.gif\" border=\"0\" value=\"submit\"/>";
  print "</form>\n";
}

function display_bulk_update($database, $user_id, $url, $rule_identifier) {
  global $style;
  global $color;
  global $theme;

  $users_location = pg_query($database, "select identifier, country, state, city, place from view_location order by country, state, city, place");
  $users_camera   = pg_query($database, "select identifier, name, model, variation from view_camera where users=$user_id");
  $users_lens     = pg_query($database, "select identifier, name, model, variation, s_min_aperture, s_max_aperture, s_min_focal_length, s_max_focal_length from view_lens where users=$user_id");
  $users_film     = pg_query($database, "select identifier, name, model, iso from view_film where users=$user_id");
  $users_flash    = pg_query($database, "select identifier, name, model, variation from view_flash where users=$user_id");
  $users_scanner  = pg_query($database, "select identifier, name, model, variation from view_scanner where users=$user_id");
  $users_filter   = pg_query($database, "select identifier, name, model, variation from view_filter where users=$user_id");
  $users_support  = pg_query($database, "select identifier, name, model, variation from view_support where users=$user_id");

  $aperture        = pg_query($database, "select identifier, value from aperture");
  $focal_length    = pg_query($database, "select identifier, value from focal_length");
  $shutter         = pg_query($database, "select identifier, value from shutter");
  $ev_comp         = pg_query($database, "select identifier, value from ev_comp");
  $camera_metering = pg_query($database, "select identifier, value from camera_metering");
  $camera_program  = pg_query($database, "select identifier, value from camera_program");
  $flash_mode      = pg_query($database, "select identifier, value from flash_mode");
  $scan_resolution = pg_query($database, "select identifier, value from scan_resolution");
  $scan_bitdepth   = pg_query($database, "select identifier, value from scan_bitdepth");
  $scan_multiscan  = pg_query($database, "select identifier, value from scan_multiscan");
  $iso_override    = pg_query($database, "select identifier, value from film_iso");

  $users_folder    = pg_query($database, "select identifier, caption, parent_folder  from folder where users=$user_id and caption!='Trash' and caption!='Orphanage' order by date_of_creation desc");
  $users_album    = pg_query($database, "select identifier, caption, parent_album from album where users=$user_id and caption!='Spool' order by date_of_creation desc");

  /* New spool code, disabled for now
  $users_spool = pg_query($database, "select album.identifier from album where caption = 'Spool' and users = $user_id");
  $spool_album=pg_fetch_row($users_spool);
  $photos_in_spooler = pg_query($database, "select photo from album_content where album = $spool_album[0]  group by photo order by photo");
  $num_photos = pg_num_rows($photos_in_spooler);
  */

  print "<form method=\"post\" action=\"bulk.update.php\" enctype=\"multipart/form-data\">\n";

  print "&nbsp;<br />";

  print "<table align=\"center\"  border=\"0\" cellspacing=\"1\" cellpadding=\"3\" width=\"100%\">\n";
  print "<tr>\n";
  print "<td align=\"left\" bgcolor=\"$color[table_top]\"  colspan=\"2\">Search Criteria</td>\n";
  print "</tr>\n";
  print "<tr><td align=\"right\" bgcolor=\"$color[table_header]\" width=\"25%\">Folder<input type=\"radio\" name=\"selection\" value=\"folder\" /></td><td align=\"left\" bgcolor=\"$color[table_body]\" >";
  display_folder_combo("select_folder", $users_folder, $current_folder, "all");
  print "</td></tr>\n";
  print "<tr><td align=\"right\" bgcolor=\"$color[table_header]\" width=\"25%\">Album<input type=\"radio\" name=\"selection\" value=\"album\"/></td><td align=\"left\" bgcolor=\"$color[table_body]\" >";
  display_album_combo("select_album", $users_album, $current_album, "");
  print "</td></tr>\n";

  /* New spool code, disabled for now
  if ($num_photos > 0) {
    print "<tr><td align=\"right\" bgcolor=\"$color[table_header]\" width=\"25%\">Spool<input type=\"radio\" name=\"selection\" value=\"spool\"/></td><td align=\"left\" bgcolor=\"$color[table_body]\" >";
    print "Photos in spool: $num_photos";
    print "<input type=\"hidden\" value=\"$spool_album[0]\"/>";
    print "</td></tr>\n";
  }
  */

  print "</table>\n";

  print "<p>&nbsp;<p>";

  print "<table align=\"center\"  border=\"0\" cellspacing=\"1\" cellpadding=\"3\" width=\"100%\">\n";
  print "<tr>\n";
  print "<td align=\"left\" bgcolor=\"$color[table_top]\"  colspan=\"2\">Action</td>\n";
  print "</tr>\n";
  print "<tr><td align=\"right\" bgcolor=\"$color[table_header]\" width=\"25%\">Regenerate thumbnail and preview</td><td align=\"left\" bgcolor=\"$color[table_body]\" >";
  display_yes_no_combo("set_generate_images", "");
  print "</td></tr>\n";

  print "<tr><td align=\"right\" bgcolor=\"$color[table_header]\" width=\"25%\">Title<input type=\"checkbox\" name=\"to_update[]\" value=\"set_title\"/></td><td align=\"left\" bgcolor=\"$color[table_body]\" >";
  print "<textarea wrap=\"soft\" name=\"set_title\" rows=\"2\"></textarea></td></tr>\n";

  print "<tr><td align=\"right\" bgcolor=\"$color[table_header]\" width=\"25%\">Author<input type=\"checkbox\" name=\"to_update[]\" value=\"set_author\"/></td><td align=\"left\" bgcolor=\"$color[table_body]\" >";
  print "<textarea wrap=\"soft\" name=\"set_author\" rows=\"2\"></textarea></td></tr>\n";

  print "<tr><td align=\"right\" bgcolor=\"$color[table_header]\" width=\"25%\">Set Keywords<input type=\"checkbox\" name=\"to_update[]\" value=\"set_keyword\"/></td><td align=\"left\" bgcolor=\"$color[table_body]\" >";
  print "<textarea wrap=\"soft\" name=\"set_keyword\" title=\"Keywords, separated by semicolons\" rows=\"3\"></textarea></td></tr>\n";

  print "<tr><td align=\"right\" bgcolor=\"$color[table_header]\" width=\"25%\">Clear Keywords<input type=\"checkbox\" name=\"to_update[]\" value=\"clear_keyword\"/></td><td align=\"left\" bgcolor=\"$color[table_body]\" >";
  print "<textarea wrap=\"soft\" name=\"clear_keyword\" title=\"Keywords, separated by semicolons\" rows=\"3\"></textarea></td></tr>\n";

  print "<tr><td align=\"right\" bgcolor=\"$color[table_header]\" width=\"25%\">Headline<input type=\"checkbox\" name=\"to_update[]\" value=\"set_headline\"/></td><td align=\"left\" bgcolor=\"$color[table_body]\" >";
  print "<textarea wrap=\"soft\" name=\"set_headline\" rows=\"2\"></textarea></td></tr>\n";

  print "<tr><td align=\"right\" bgcolor=\"$color[table_header]\" width=\"25%\">Caption Writer<input type=\"checkbox\" name=\"to_update[]\" value=\"set_caption_writer\"/></td><td align=\"left\" bgcolor=\"$color[table_body]\" >";
  print "<textarea wrap=\"soft\" name=\"set_caption_writer\" rows=\"2\"></textarea></td></tr>\n";

  print "<tr><td align=\"right\" bgcolor=\"$color[table_header]\" width=\"25%\">Caption<input type=\"checkbox\" name=\"to_update[]\" value=\"set_caption\"/></td><td align=\"left\" bgcolor=\"$color[table_body]\" >";
  print "<textarea wrap=\"soft\" name=\"set_caption\" rows=\"7\"></textarea></td></tr>\n";

  print "<tr><td align=\"right\" bgcolor=\"$color[table_header]\" width=\"25%\">Category<input type=\"checkbox\" name=\"to_update[]\" value=\"set_category\"/></td><td align=\"left\" bgcolor=\"$color[table_body]\" >";
  print "<input type=\"text\" name=\"set_category\" size=\"3\" title=\"Category\" value=\"\"/></td></tr>\n";

  print "<tr><td align=\"right\" bgcolor=\"$color[table_header]\" width=\"25%\">Supplemental Category<input type=\"checkbox\" name=\"to_update[]\" value=\"set_supplemental_category\"/></td><td align=\"left\" bgcolor=\"$color[table_body]\" >";
  print "<textarea wrap=\"soft\" name=\"set_supplemental_category\" rows=\"7\"></textarea></td></tr>\n";

  print "<tr><td align=\"right\" bgcolor=\"$color[table_header]\" width=\"25%\">Credit<input type=\"checkbox\" name=\"to_update[]\" value=\"set_credit\"/></td><td align=\"left\" bgcolor=\"$color[table_body]\" >";
  print "<textarea wrap=\"soft\" name=\"set_credit\" rows=\"2\"></textarea></td></tr>\n";

  print "<tr><td align=\"right\" bgcolor=\"$color[table_header]\" width=\"25%\" nowrap=\"nowrap\">Copyright Statement<input type=\"checkbox\" name=\"to_update[]\" value=\"set_copyright\"/></td> <td align=\"left\" bgcolor=\"$color[table_body]\" width=\"70%\">";
  print "<textarea wrap=\"hard\" name=\"set_copyright\" rows=\"7\"></textarea>\n";

  print "<tr><td align=\"right\" bgcolor=\"$color[table_header]\" width=\"25%\">Web Statement<input type=\"checkbox\" name=\"to_update[]\" value=\"set_web_statement\"/></td><td align=\"left\" bgcolor=\"$color[table_body]\" >";
  print "<textarea wrap=\"soft\" name=\"set_web_statement\" rows=\"2\"></textarea></td></tr>\n";

  print "<tr><td align=\"right\" bgcolor=\"$color[table_header]\" width=\"25%\">Instructions<input type=\"checkbox\" name=\"to_update[]\" value=\"set_instructions\"/></td><td align=\"left\" bgcolor=\"$color[table_body]\" >";
  print "<textarea wrap=\"soft\" name=\"set_instructions\" rows=\"2\"></textarea></td></tr>\n";

  print "<tr><td align=\"right\" bgcolor=\"$color[table_header]\" width=\"25%\">Source<input type=\"checkbox\" name=\"to_update[]\" value=\"set_source\"/></td><td align=\"left\" bgcolor=\"$color[table_body]\" >";
  print "<textarea wrap=\"soft\" name=\"set_source\" rows=\"2\"></textarea></td></tr>\n";

  print "<tr><td align=\"right\" bgcolor=\"$color[table_header]\" width=\"25%\">Transmission Reference<input type=\"checkbox\" name=\"to_update[]\" value=\"set_transmission_reference\"/></td><td align=\"left\" bgcolor=\"$color[table_body]\" >";
  print "<textarea wrap=\"soft\" name=\"set_transmission_reference\" rows=\"2\"></textarea></td></tr>\n";

  print "<tr><td align=\"right\" bgcolor=\"$color[table_header]\" width=\"25%\">Date of Exposure<input type=\"checkbox\" name=\"to_update[]\" value=\"set_date_of_exposure\"/></td><td align=\"left\" valign=\"middle\" bgcolor=\"$color[table_body]\" >";
  display_date_input_form("set_date_of_exposure", "");
  print "</td></tr>\n";

  print "<tr><td align=\"right\" bgcolor=\"$color[table_header]\" width=\"25%\">Location<input type=\"checkbox\" name=\"to_update[]\" value=\"set_location\"/></td><td align=\"left\" bgcolor=\"$color[table_body]\" >";
  display_combo("set_location", $users_location, "0", ", ", 1);
  print "</td></tr>\n";

  print "<tr><td align=\"right\" bgcolor=\"$color[table_header]\" width=\"25%\">Access<input type=\"checkbox\" name=\"to_update[]\" value=\"set_access_rights\"/></td><td align=\"left\" bgcolor=\"$color[table_body]\" >";
  display_access_combo("set_access_rights", "", "null");
  print "</td></tr>\n";

  print "<tr><td align=\"right\" bgcolor=\"$color[table_header]\" width=\"25%\">High Resolution Original<input type=\"checkbox\" name=\"to_update[]\" value=\"set_hide_original\"/></td><td align=\"left\" valign=\"middle\" bgcolor=\"$color[table_body]\" >";
  display_hide_original_combo("set_hide_original", "");
  print "</td></tr>\n";

  print "<tr><td align=\"right\" bgcolor=\"$color[table_header]\" width=\"25%\">Camera<input type=\"checkbox\" name=\"to_update[]\" value=\"set_camera\"/></td><td align=\"left\" bgcolor=\"$color[table_body]\" >";
  display_combo("set_camera", $users_camera, "", "", 0);
  print "</td></tr>\n";

  print "<tr><td align=\"right\" bgcolor=\"$color[table_header]\" width=\"25%\">Camera Metering<input type=\"checkbox\" name=\"to_update[]\" value=\"set_camera_metering\"/></td><td align=\"left\" bgcolor=\"$color[table_body]\" >\n";
  display_combo("set_camera_metering", $camera_metering, "", "", 0);
  print "</td></tr>\n";

  print "<tr><td align=\"right\" bgcolor=\"$color[table_header]\" width=\"25%\">Camera Program<input type=\"checkbox\" name=\"to_update[]\" value=\"set_camera_program\"/></td><td align=\"left\" bgcolor=\"$color[table_body]\" >\n";
  display_combo("set_camera_program", $camera_program, "", "", 0);
  print "</td></tr>\n";

  print "<tr><td align=\"right\" bgcolor=\"$color[table_header]\" width=\"25%\">Lens<input type=\"checkbox\" name=\"to_update[]\" value=\"set_lens\"/></td><td align=\"left\" bgcolor=\"$color[table_body]\" >\n";
  display_lens_combo("set_lens", $users_lens, "", 0, 0);
  print "</td></tr>\n";

  print "<tr><td align=\"right\" bgcolor=\"$color[table_header]\" width=\"25%\">Focal Length<input type=\"checkbox\" name=\"to_update[]\" value=\"set_focal_length\"/></td><td align=\"left\" bgcolor=\"$color[table_body]\" >\n";
  display_combo("set_focal_length", $focal_length, "", "", 0);
  print "</td></tr>\n";

  print "<tr><td align=\"right\" bgcolor=\"$color[table_header]\" width=\"25%\">Filter<input type=\"checkbox\" name=\"to_update[]\" value=\"set_filter\"/></td><td align=\"left\" bgcolor=\"$color[table_body]\" >\n";
  display_combo("set_filter", $users_filter, "", "", 0);
  print "</td></tr>\n";

  print "<tr><td align=\"right\" bgcolor=\"$color[table_header]\" width=\"25%\">Film<input type=\"checkbox\" name=\"to_update[]\" value=\"set_film\"/></td><td align=\"left\" bgcolor=\"$color[table_body]\" >\n";
  display_combo("set_film", $users_film, "", "", 0);
  print "</td></tr>\n";

  print "<tr><td align=\"right\" bgcolor=\"$color[table_header]\" width=\"25%\">Film ISO Override<input type=\"checkbox\" name=\"to_update[]\" value=\"set_iso_override\"/></td><td align=\"left\" bgcolor=\"$color[table_body]\" >\n";
  display_combo("set_iso_override", $iso_override, "", "", 0);
  print "</td></tr>\n";

  print "<tr><td align=\"right\" bgcolor=\"$color[table_header]\" width=\"25%\">Aperture<input type=\"checkbox\" name=\"to_update[]\" value=\"set_aperture\"/></td><td align=\"left\" bgcolor=\"$color[table_body]\" >";
  display_combo("set_aperture", $aperture, "", "", 0);
  print "</td></tr>\n";

  print "<tr><td align=\"right\" bgcolor=\"$color[table_header]\" width=\"25%\">Shutter Speed<input type=\"checkbox\" name=\"to_update[]\" value=\"set_shutter\"/></td><td align=\"left\" bgcolor=\"$color[table_body]\" >\n";
  display_combo("set_shutter", $shutter, "", "", 0);
  print "</td></tr>\n";

  print "<tr><td align=\"right\" bgcolor=\"$color[table_header]\" width=\"25%\">Exposure Compensation<input type=\"checkbox\" name=\"to_update[]\" value=\"set_exp_comp\"/></td><td align=\"left\" bgcolor=\"$color[table_body]\" >\n";
  display_combo("set_exp_comp", $ev_comp, "", "", 0);
  print "</td></tr>\n";

  print "<tr><td align=\"right\" bgcolor=\"$color[table_header]\" width=\"25%\">Ev Difference<input type=\"checkbox\" name=\"to_update[]\" value=\"set_exp_diff\"/></td><td align=\"left\" bgcolor=\"$color[table_body]\" >\n";
  display_combo("set_exp_diff", $ev_comp, "", "", 0);
  print "</td></tr>\n";

  print "<tr><td align=\"right\" bgcolor=\"$color[table_header]\" width=\"25%\">Flash<input type=\"checkbox\" name=\"to_update[]\" value=\"set_flash\"/></td><td align=\"left\" bgcolor=\"$color[table_body]\" >\n";
  display_combo("set_flash", $users_flash, "", "", 0);
  print "</td></tr>\n";

  print "<tr><td align=\"right\" bgcolor=\"$color[table_header]\" width=\"25%\">Flash Mode<input type=\"checkbox\" name=\"to_update[]\" value=\"set_flash_mode\"/></td><td align=\"left\" bgcolor=\"$color[table_body]\" >\n";
  display_combo("set_flash_mode", $flash_mode, "", "", 0);
  print "</td></tr>\n";

  print "<tr><td align=\"right\" bgcolor=\"$color[table_header]\" width=\"25%\">Flash Compensation<input type=\"checkbox\" name=\"to_update[]\" value=\"set_flash_comp\"/></td><td align=\"left\" bgcolor=\"$color[table_body]\" >\n";
  display_combo("set_flash_comp", $ev_comp, "", "", 0);
  print "</td></tr>\n";

  print "<tr><td align=\"right\" bgcolor=\"$color[table_header]\" width=\"25%\">Colorspace<input type=\"checkbox\" name=\"to_update[]\" value=\"set_colorspace\"/></td><td align=\"left\" bgcolor=\"$color[table_body]\" >\n";
  display_colorspace_combo("colorspace", 1);
  print "</td></tr>\n";

  print "<tr><td align=\"right\" bgcolor=\"$color[table_header]\" width=\"25%\">Scanner<input type=\"checkbox\" name=\"to_update[]\" value=\"set_scanner\"/></td><td align=\"left\" bgcolor=\"$color[table_body]\" >\n";
  display_combo("set_scanner", $users_scanner, "", "", 0);
  print "</td></tr>\n";

  print "<tr><td align=\"right\" bgcolor=\"$color[table_header]\" width=\"25%\">Scan Parameters<input type=\"checkbox\" name=\"to_update[]\" value=\"set_scan_params\"/></td><td align=\"left\" bgcolor=\"$color[table_body]\" >\n";
  display_combo("set_scan_resolution", $scan_resolution, "", "", 0);
  print "dpi &nbsp;\n";
  display_combo("set_scan_bitdepth", $scan_bitdepth, "", "", 0);
  print "bits &nbsp;\n";
  display_combo("set_scan_multiscan", $scan_multiscan, "", "", 0);
  print "passes &nbsp;\n";
  print "</td></tr>\n";

  print "<tr><td align=\"right\" bgcolor=\"$color[table_header]\" width=\"25%\">Support<input type=\"checkbox\" name=\"to_update[]\" value=\"set_support\"/></td><td align=\"left\" bgcolor=\"$color[table_body]\" >\n";
  display_combo("set_support", $users_support, "", "", 0);
  print "</td></tr>\n";

  print "</table>\n";

  print "&nbsp;<br/>";

  print "<input type=\"image\" src=\"$theme/button.submit.gif\"  name=\"operator\" value=\"submit\"/>";
  print "</form>\n";
}


function display_shop_item_generator($database, $user_id) {
  global $style;
  global $color;
  global $theme;

  print "<script language=\"JavaScript\" type=\"text/javascript\" src=\"javascript/select.js\"></script>";

  $users_folder = pg_query($database, "select identifier, caption, parent_folder  from folder where users=$user_id and caption!='Trash' and caption!='Orphanage' order by date_of_creation desc");
  $all_user_rules  = pg_query($database, "
     select identifier, shop_category, shop_item, currency, price, comment, date_of_creation, date_of_last_edit
       from view_shop_item_generator_rule
      where users=$user_id");

  print "&nbsp;<br />";

  print "<form name=\"shop_item_generator\" method=\"post\" action=\"shop.item.generator.php\" enctype=\"multipart/form-data\">\n";
  print "<table align=\"center\"  border=\"0\" cellspacing=\"1\" cellpadding=\"3\" width=\"100%\">\n";
  print "<tr>\n";
  print "<td align=\"left\" bgcolor=\"$color[table_top]\"  colspan=\"2\">Search Criteria</td>\n";
  print "</tr>\n";
  print "<tr><td align=\"right\" bgcolor=\"$color[table_header]\" width=\"25%\">Folder</td><td align=\"left\" bgcolor=\"$color[table_body]\" >";
  display_folder_combo("select_folder", $users_folder, $current_folder, "all");
  print "</td></tr>\n";
  print "</table>\n";

  print "&nbsp;<br/>\n";

  print "<table align=\"center\"  border=\"0\" cellspacing=\"1\" cellpadding=\"3\" width=\"100%\">\n";
  print "<tr>\n";
  print "<td align=\"left\" bgcolor=\"$color[table_top]\"  colspan=\"8\">Create Shop Items</td>\n";
  print "</tr>\n";
  print "<tr>\n";
  print "<td align=\"left\" bgcolor=\"$color[table_header]\" width=\"1%\">&nbsp;</td>\n";
  print "<td align=\"left\" bgcolor=\"$color[table_header]\" width=\"15%\">Category</td>\n";
  print "<td align=\"left\" bgcolor=\"$color[table_header]\" width=\"15%\">Item</td>\n";
  print "<td align=\"left\" bgcolor=\"$color[table_header]\" width=\"10%\">Currency</td>\n";
  print "<td align=\"left\" bgcolor=\"$color[table_header]\" width=\"10%\">Price</td>\n";
  print "<td align=\"left\" bgcolor=\"$color[table_header]\" width=\"39%\">Remark</td>\n";
  print "<td align=\"left\" bgcolor=\"$color[table_header]\" width=\"10%\" colspan=\"2\"><a href=\"shop.item.generator.add.php\">Add Rule</a></td>\n";
  print "</tr>\n";
  for ($f=0; $f < pg_num_rows($all_user_rules); $f++) {
    $rules = pg_fetch_row($all_user_rules, $f);
    print "<tr>\n";
    print "<td align=\"left\" bgcolor=\"$color[table_body]\"><input type=\"checkbox\" name=\"rule$rules[0]\" value=\"$rules[0]\" onClick=\"sig_uncheck_del();\"/></td>\n";
    print "<td align=\"left\" bgcolor=\"$color[table_body]\">$rules[1]</td>\n";
    print "<td align=\"left\" bgcolor=\"$color[table_body]\">$rules[2]</td>\n";
    print "<td align=\"left\" bgcolor=\"$color[table_body]\">$rules[3]</td>\n";
    print "<td align=\"left\" bgcolor=\"$color[table_body]\">$rules[4]</td>\n";
    print "<td align=\"left\" bgcolor=\"$color[table_body]\">$rules[5]</td>\n";
    print "<td align=\"left\" bgcolor=\"$color[table_body]\" width=\"5%\"><a href=\"shop.item.generator.edit.php?rule=$rules[0]\">Edit</a></td>\n";
    print "<td align=\"left\" bgcolor=\"$color[table_body]\" width=\"5%\"><a href=\"shop.item.generator.del.php?rule=$rules[0]\">Delete</a></td>\n";
    print "</tr>\n";
  }
  print "<tr>\n";
  print "<td align=\"left\" bgcolor=\"$color[table_header]\"><input type=\"checkbox\" name=\"delete_all\" value=\"yes\" onClick=\"sig_uncheck_create();\"/></td>\n";
  print "<td align=\"left\" bgcolor=\"$color[table_header]\" colspan=\"7\">Remove all shop items in the specified folder.</td>\n";
  print "</tr>\n";
  print "</table>\n";
  print "&nbsp;<br/>\n";
  print "<input type=\"image\" src=\"$theme/button.submit.gif\" border=\"0\" name=\"operator\" value=\"submit\"/>\n";
  print "</form>\n";

  print "&nbsp;<br/>\n";

}

function display_content_indexer($database, $user_id, $url, $session_id) {
  global $style;
  global $color;
  global $theme;

  $users_folder = pg_query($database, "select identifier, caption, parent_folder  from folder where users=$user_id and caption!='Trash' and caption!='Orphanage' order by date_of_creation desc");

  print "&nbsp;<br />";

  print "<form method=\"post\" action=\"content.indexer.php\" enctype=\"multipart/form-data\">\n";
  print "<table align=\"center\"  border=\"0\" cellspacing=\"1\" cellpadding=\"3\" width=\"100%\">\n";
  print "<tr>\n";
  print "<td align=\"left\" bgcolor=\"$color[table_top]\"  colspan=\"2\">Search Criteria</td>\n";
  print "</tr>\n";
  print "<tr><td align=\"right\" bgcolor=\"$color[table_header]\" width=\"25%\">Folder</td><td align=\"left\" bgcolor=\"$color[table_body]\" >";
  display_folder_combo("select_folder", $users_folder, 0, "all");
  print "</td></tr>\n";
  print "</table>\n";

  print "&nbsp;<br/>\n";

  print "<table align=\"center\"  border=\"0\" cellspacing=\"1\" cellpadding=\"3\" width=\"100%\">\n";
  print "<tr><td align=\"left\" bgcolor=\"$color[table_body]\" >\n";
  display_content_submit("type");
  print "</td></tr>";
  print "</table>\n";
  print "&nbsp;<br/>\n";
  print "<input type=\"image\" src=\"$theme/button.submit.gif\" border=\"0\" name=\"operator\" value=\"submit\"/>\n";
  print "</form>\n";

  print "&nbsp;<br/>\n";
}

?>
