<?php

//  Copyright (C) 2002-2006 Balint Kis (balint@k-i-s.net)
//  Copyright (C) 2005-2007 Solomon Peachy (pizza@shaftnet.org)

//  This program is free software; you can redistribute it and/or modify
//  it under the terms of the GNU General Public License as published by
//  the Free Software Foundation; either version 2 of the License, or
//  (at your option) any later version.

//  This program is distributed in the hope that it will be useful,
//  but WITHOUT ANY WARRANTY; without even the implied warranty of
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//  GNU General Public License for more details.

//  You should have received a copy of the GNU General Public License
//  along with this program; if not, write to the Free Software
//  Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA

include_once "include/vars.php";
include_once "include/config.php";
include_once "$theme/theme.php";
include_once "include/common.php";
include_once "include/site.php";

$database = site_prolog();

if ($po_user['type'] < $user_type['user']) {
  site_epilog($database);
  header("location: login.php");
  exit();
}

$photo_id = pg_escape_string($_REQUEST['photo']);
$item     = pg_escape_string($_REQUEST['item']);
$category = pg_escape_string($_REQUEST['category']);

$photo_data = pg_fetch_row(pg_query($database, "
  select users, caption, medium_image_path, large_image_path, hide_original, title
    from photo, photo_version
   where photo.identifier = photo_version.photo
     and photo_version.master = 't'
     and photo.identifier = '$photo_id'"));
$folder_data = pg_fetch_row(pg_query($database, "
  select folder.identifier, folder.caption
    from photo, folder
   where photo.folder = folder.identifier
     and photo.identifier='$photo_id'"));
$user_name   = pg_fetch_row(pg_query($database, "
  select identifier, last_name, first_name
    from users
   where identifier=$photo_data[0]"));

$photo_for_sale = pg_fetch_row(pg_query($database, "
  select shop_item, price, currency, comment, category
    from photo_item, shop_item
   where photo_item.shop_item = shop_item.identifier
     and photo_item.identifier=$item
     and photo='$photo_id'"));

site_header($page_width, "Edit Photo Shop Item");

if ($po_user['id'] == $photo_data[0]) {
  site_navigator(5);
  $user_display_string = "My folders and albums";
}
else {
  site_navigator(1);
  $user_display_string = sprintf("%s, %s", $user_name[1], $user_name[2]);
}
$path_to_folder = get_path_to_folder($database, $folder_data[0]);
$title = get_photo_title($photo_data[1], $photo_data[5]);
site_navigator_status("<a href=\"user.php\">Users</a> : <a href=\"user.php?user=$user_name[0]\">$user_display_string</a>$path_to_folder : <a href=\"folder.php?folder=$folder_data[0]\">$folder_data[1]</a> : <a href=\"photo.php?photo=$photo_id\">$title</a> : Edit Photo Shop Item", "");

print "&nbsp;<br/>\n";
print "<center>\n";
display_shaded_photo("image.display.php?image=$photo_id&size=2&ver=$version", "", $image_repository_path . "/" . $photo_data[2]);
print "</center>\n";
print "&nbsp;<br/>\n";

$all_shop_categories = pg_query($database, "
   select identifier, caption
     from shop_category
    where identifier in (select category from shop_item)
      and users=$po_user[id]");
if (!$category) {
  $category = $photo_for_sale[4];
}
$all_shop_items = pg_query($database, "select identifier, description from shop_item where users=$po_user[id] and category=$category");
$all_currencies  = pg_query($database, "select identifier, alpha_code, name, entity from currency");

print "<form method=\"post\" action=\"photo.item.edit.2.php\">\n";
print "<input type=\"hidden\" name=\"photo\" value=\"$photo_id\"/>\n";
print "<input type=\"hidden\" name=\"item\" value=\"$item\"/>\n";
print "<table align=\"center\" bgcolor=\"$color[table_background]\" border=\"0\" cellspacing=\"1\" cellpadding=\"3\" width=\"100%\">\n";
print "<tr>";
print "<td align=\"left\" bgcolor=\"$color[table_top]\"  width=\"15%\"><a href=\"my.profile.php?selector=10\">Category</a></td>";
print "<td align=\"left\" bgcolor=\"$color[table_top]\"  width=\"15%\"><a href=\"my.profile.php?selector=10\">Item</a></td>";
print "<td align=\"left\" bgcolor=\"$color[table_top]\"  width=\"10%\">Price</td>";
print "<td align=\"left\" bgcolor=\"$color[table_top]\"  width=\"10%\">Currency</td>";
print "<td align=\"left\" bgcolor=\"$color[table_top]\"  width=\"50%\">Remark</td>";
print "</tr><tr>";
print "<td align=\"left\" bgcolor=\"$color[table_body]\" >";
print "<select onchange=\"location = this.options[this.selectedIndex].value;\"\">";
for ($f=0; $f < pg_num_rows($all_shop_categories); $f++) {
  $single_category = pg_fetch_row($all_shop_categories, $f);
  print "<option value=\"photo.item.edit.php?photo=$photo_id&item=$item&category=$single_category[0]\"";
  if ($single_category[0] == $category) {
    print " selected ";
  }
  print ">$single_category[1]\n";
}
print "</select>";
print "</td>";
print "<td align=\"left\" bgcolor=\"$color[table_body]\" >";
display_combo('shop_item', $all_shop_items, $photo_for_sale[0], "", TRUE);
print "</td>";
print "<td align=\"left\" bgcolor=\"$color[table_body]\" ><input type=\"text\" name=\"price\" value=\"$photo_for_sale[1]\"/></td>";
print "<td align=\"left\" bgcolor=\"$color[table_body]\" >";
display_currency_combo('currency', $all_currencies, $photo_for_sale[2], TRUE);
print "</td>";
print "<td align=\"left\" bgcolor=\"$color[table_body]\" ><input type=\"text\" name=\"comment\" value=\"$photo_for_sale[3]\" size=\"50%\"/></td>";
print "</tr>";
print "</table>\n";
print "&nbsp;<br/>\n";
print "<input type=\"image\" src=\"$theme/button.save.changes.gif\" border=\"0\" value=\"Save Changes\"/>\n";
print "<a class=\"nodecor\" href=\"photo.php?photo=$photo_id&detail_info=8\"><img src=\"$theme/button.cancel.gif\" border=\"0\" alt=\"Cancel\"/></a>\n";
print "</form>\n";
print "&nbsp;<br/>\n";

site_footer($database);
site_epilog($database);
?>
